# Microsoft Teams App Project Generator - #YoTeams

[![npm version](https://badge.fury.io/js/generator-teams.svg)](https://www.npmjs.com/package/generator-teams)
[![npm](https://img.shields.io/npm/dt/generator-teams.svg)](https://www.npmjs.com/package/generator-teams)
[![MIT](https://img.shields.io/npm/l/generator-teams.svg)](https://github.com/pnp/generator-teams/blob/preview/LICENSE.md)
[![GitHub issues](https://img.shields.io/github/issues/PnP/generator-teams.svg)](https://github.com/PnP/generator-teams/issues)
[![GitHub closed issues](https://img.shields.io/github/issues-closed/PnP/generator-teams.svg)](https://github.com/PnP/generator-teams/issues?q=is%3Aissue+is%3Aclosed)
[![GitHub stars](https://img.shields.io/github/stars/PnP/generator-teams.svg)](https://github.com/PnP/generator-teams/stargazers)
[![Discussions](https://img.shields.io/badge/discuss-on%20Github-green)](https://github.com/pnp/generator-teams/discussions)

 | @master | @preview | @next |
 :--------:|:--------:|:------:
 [![npm (latest)](https://img.shields.io/npm/v/generator-teams/latest.svg)](https://www.npmjs.com/package/generator-teams)|[![npm (preview)](https://img.shields.io/npm/v/generator-teams/preview.svg)](https://www.npmjs.com/package/generator-teams)|[![npm (next)](https://img.shields.io/npm/v/generator-teams/next.svg)](https://www.npmjs.com/package/generator-teams)
 ![Build generator-teams](https://github.com/pnp/generator-teams/workflows/Build%20generator-teams/badge.svg)|![Build generator-teams](https://github.com/pnp/generator-teams/workflows/Build%20generator-teams/badge.svg?branch=preview)|![Build generator-teams](https://github.com/pnp/generator-teams/workflows/Build%20generator-teams/badge.svg?branch=next)

A [Yeoman Generator](http://yeoman.io/) for [Microsoft Teams](https://teams.microsoft.com) Apps projects. **The most comprehensive and complete development toolkit for Microsoft Teams development**. This generator is for developers who prefers to use TypeScript, React and node as their primary technologies.

The generator allows you to simply create and scaffold projects that includes one or more Microsoft Teams features such as:

* Bots - based on Bot Framework
* Messaging Extensions - actions and query
* Tabs, with support for Single-Sign-On
* Connectors
* Outgoing Webhooks

When scaffolding the project you will also have the option of adding additional features to your project such as:

* Simple deployment (including a pre-configured Docker file)
* Add unit testing framework and sample unit tests
* Easily develop and debug using ngrok
* Easily develop and debug using Github Codespaces
* Application Insights support

## Documentation

The documentation for the generator and the generated project can be found in the [generator-teams Github repository](https://github.com/pnp/generator-teams/tree/master/docs/docs).

## The generated project

When the generator is done you can start working with your project. Make sure to read the generated README.md file for more instructions. The generated artifacts contain sample code as well as detailed documentation on the required steps that is required for you when registering Connectors and Bots.

The solution can be built using the Gulp task `build` and hosted on a local web server using the Gulp task `serve`. The Teams Application manifest is generated by executing the Gulp task `manifest` - that will validate and create the ZIP file that you upload to Microsoft Teams.

## yo teams Demo

![Demo](https://github.com/pnp/generator-teams/blob/main/docs/assets/demo.gif?raw=true)

## Install

> **Important:** If this is the first time you're using Yeoman or installing a Yeoman generator, first install [Node.js](https://nodejs.org). For developers on Mac, we recommend using [Node Version Manager](https://github.com/creationix/nvm) to install Node.js with the right permissions. When the installation completes, restart your console (or if you are using Windows, restart your machine) to ensure you use the updated system environment variables.

### Prerequisites

Install `yo` (Yeoman), `gulp-cli` (Gulp global command line interface) and `typescript` (Typescript compiler) globally using NPM.

``` Shell
npm install yo gulp-cli typescript --global
```

### Released and stable version

Install `generator-teams` globally using NPM.

```Shell
npm install generator-teams --global
```

### Preview versions

Preview versions of the generator will be published with the **preview** tag and can be installed using the following command:

``` Shell
npm install generator-teams@preview --global
```

## Usage

``` Shell
yo teams [arguments]
```

> *Note:* Files are created in the directory that you run the command from hence make sure you are happy with the location before you hit enter.

### Arguments

 The following arguments can be used:

* `--skip-install` - when used no packages will be installed at the end of the generator and you have to run `npm install` or similar manually.
* `--no-telemetry` - opt out of sending telemetry data (NOTE: no personal data or names of artifacts are being sent, only information of successful executions and what options are being used).
* `--node-package-manager npm|yarn` - specify package manager to use. Default `npm`

## Build the generator

If you are interested in contributing or modifying the generator itself, you clone this repository and then install all modules before building the solution.

``` Shell
npm install
npm run build
```

The bundled generator and the template files will end up in the `./generators/` folder.

## Test the generator

If you want to run the generator tests, you can run the following command.

``` Shell
npm test
```

Yeoman-test package is being used for the generator tests.

### Use it in dev mode

In the `generator-teams` directory use the following command, this will link the local copy of the folder as a global node module.

``` Shell
npm link
```

To revert the link operation:

``` Shell
npm unlink
```

## More information

For more information on the generator [see the Github repo for Yo Teams](https://aka.ms/yoteams).

## Contributing

This project has adopted the [Microsoft Open Source Code of Conduct](https://opensource.microsoft.com/codeofconduct/). For more information see the [Code of Conduct FAQ](https://opensource.microsoft.com/codeofconduct/faq/) or contact [opencode@microsoft.com](mailto:opencode@microsoft.com) with any additional questions or comments.
